{------------------------------------------------------------------------------

Copyright (C) 2002  Rainer Queck
e-mail: Rainer.Queck@Qutronic.de
http://www.qutronic.de


This code is free; you can redistribute it and/or
modify it under the terms of the MPL MOZILLA PUBLIC LICENSE. 

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
MPL MOZILLA PUBLIC LICENSE for more details at http://www.mozilla.org/MPL

//-----------------------------------------------------------------------------}
// Unit Created at    : somewhen in 2002
// Unit last modified : Date: 17.04.03  Time :08:13:06
//------------------------------------------------------------------------------
unit InfoForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TQutronicInfoFrm = class (TForm)
    Button1: TButton;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    lbVersion: TLabel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  public
    function GetVersionInfo(const AFileName: String; Var VerString : String): 
            Integer;
    function MakeVersionString(aVersion : String): string;
  end;
  
var
  QutronicInfoFrm: TQutronicInfoFrm;

implementation

{$R *.DFM}

{
******************************* TQutronicInfoFrm *******************************
}
procedure TQutronicInfoFrm.Button1Click(Sender: TObject);
begin
  close;
end;

procedure TQutronicInfoFrm.FormActivate(Sender: TObject);
begin
  Timer1.Enabled:=True;
end;

procedure TQutronicInfoFrm.FormCreate(Sender: TObject);
var
  aStr: string;
  aFileName: string;
begin
  aFileName:=Application.ExeName;
  aFileName:=StringReplace(aFileName,'\bin\mm7.exe','\Experts\QMMEOpen.dll',[rfReplaceAll]);
  aStr:='Generation Date: 17.04.03 08:13:06';
  if FileExists(aFileName) then
  begin
    GetVersionInfo(aFileName,aStr);
    aStr:=MakeVersionString(aStr);
  end;
  lbVersion.Caption:=aStr;
end;

function TQutronicInfoFrm.GetVersionInfo(const AFileName: String; Var VerString 
        : String): Integer;
var
  i: Integer;
  j: UINT;
  h: THandle;
  p: Pointer;
  pw: PWordArray;
  pc: PChar;
  s: string;
begin
  result:=-1;
  i := GetFileVersionInfoSize(PChar(AFileName), h);
  if i > 0 then
  begin
    Getmem(p, i);
    try
      if GetFileVersionInfo(PChar(AFileName), h, i, p) and
         (VerQueryValue(p, '\VarFileInfo\Translation', pointer(pw), j)) and
         (j >= SizeOf(Integer)) then
        begin
          i := (pw^[0] shl 16) + pw^[1];
          s := '\StringFileInfo\' + IntToHex(i, 8) + '\';
          if VerQueryValue(p, PChar(s + 'FileVersion'), pointer(pc), j) then
          begin
            VerString:=String(pc);
            pc := StrRScan(pc, '.'); // take last part of Version (number of compilations)
            if Assigned(pc) then
              Result := StrToIntDef(string(pc + 1), -1);
          end;
        end;
    finally
      Freemem(p);
    end;
  end;
end;

function TQutronicInfoFrm.MakeVersionString(aVersion : String): string;
var
  aStr: string;
begin
  // '1.1.0.39' -> Version 1.1.0 built 39
  //function StrRScan(const Str: PChar; Chr: Char): PChar;
  aStr:=String(StrRScan(PChar(aVersion),'.'));
  Result:=StringReplace(aVersion,aStr,'',[rfReplaceAll]);
  aStr:=StringReplace(aStr,'.','',[rfReplaceAll]);
  Result:='Version '+Result+' build '+aStr;
end;

procedure TQutronicInfoFrm.Timer1Timer(Sender: TObject);
begin
  close;
end;

end.



