{------------------------------------------------------------------------------

Copyright (C) 2002  Rainer Queck
e-mail: Rainer.Queck@Qutronic.de
http://www.qutronic.de


This code is free; you can redistribute it and/or
modify it under the terms of the MPL MOZILLA PUBLIC LICENSE. 

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
MPL MOZILLA PUBLIC LICENSE for more details at http://www.mozilla.org/MPL

//-----------------------------------------------------------------------------}
// Unit Created at    : Date: 16.02.02  Time :13:18:19
// Unit last modified : Date: 23.02.02  Time :13:57:02
//------------------------------------------------------------------------------
library QMMEOpen;

uses
  SysUtils,
  Windows,
  Forms,
  Classes,
  MMToolsApi,
  QutronicExpertClasses in 'QutronicExpertClasses.PAS',
  PrjNotify in 'PrjNotify.pas',
  QutronicBaseExpert in 'QutronicBaseExpert.pas',
  ExpertInterface in 'ExpertInterface.PAS',
  InfoForm in 'InfoForm.pas' {QutronicInfoFrm},
  QmmeMain in 'QmmeMain.pas' {FrmMain},
  DiagramGrouping in 'DiagramGrouping.PAS',
  Autodiagramming in 'Autodiagramming.PAS',
  RQClasses in 'RQClasses.PAS',
  MailBoxRq in 'MailBoxRq.pas',
  TypeStream in 'TypeStream.PAS';

{$R *.RES}

procedure InitializeExpert(const Srv: IMMToolServices); stdcall;
begin
  // Copy interface pointer to initialize global var in MMToolsApi.pas
  MMToolServices := Srv;
  // Register the expert
  Srv.AddExpert(TQutronicExpertInterface.Create);

  // Adding a Project Notifier is not neccesary for most Experts, it's included here for
  // Demo purposes only
  // Create a project notifier
  ProjectNotifier := TProjectNotifier.Create;
  // And Register an interface pointer
  Srv.AddProjectNotifier(ProjectNotifier);

  // now sync with parent window, if we omit this, modal dialogs won't be really modal and
  // modeless forms will behave even worse.
  Application.Handle := Srv.GetParentHandle;
end;

procedure FinalizeExpert; stdcall;
begin
  // there's no need to export this function is there's nothing to clean up
  // In this demo expert all the cleaning-up is done by the Expert.Destroyed
end;

function ExpertVersion: LongInt; stdcall;
begin
  // This funciton and it's implementation are mandatory, if this function is not
  // exported or the version mismatches the version in ModelMaker, the expert is not
  // loaded
  Result := MMToolsApiVersion;
end;

exports
  InitializeExpert name MMExpertEntryProcName,
  FinalizeExpert name MMExpertExitProcName,
  ExpertVersion name MMExpertVersionProcName;

end.







