{------------------------------------------------------------------------------

Copyright (C) 2002  Rainer Queck
e-mail: Rainer.Queck@Qutronic.de
http://www.qutronic.de


This code is free; you can redistribute it and/or
modify it under the terms of the MPL MOZILLA PUBLIC LICENSE. 

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
MPL MOZILLA PUBLIC LICENSE for more details at http://www.mozilla.org/MPL

//---------------------------------------------------------------------------}
// Unit Created at    : somewhen in 2002
// Unit last modified : Date: 17.04.03  Time :08:14:22
//------------------------------------------------------------------------------
unit QmmeMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ImgList, ComCtrls, ToolWin, Menus, ExtCtrls,
  QutronicExpertClasses,clipbrd,DiagramGrouping,InfoForm,Autodiagramming,
  MMToolsAPI,MMEngineDefs,RQClasses;

type
  TFrmMain = class (TForm)
    About1: TMenuItem;
    AutoDiagramming1: TMenuItem;
    btFileSave: TSpeedButton;
    btHide: TButton;
    btLoadFromFile: TSpeedButton;
    btMoveMsg: TButton;
    btReload: TSpeedButton;
    Button1: TSpeedButton;
    cbxDgGroupSelect: TComboBox;
    FindStringInModel1: TMenuItem;
    GuiHide: TMenuItem;
    Label1: TLabel;
    lbDgCount: TLabel;
    lbxDgGroupMemberList: TListBox;
    lbxInvalidDGMembers: TListBox;
    lbxMethodRef: TListBox;
    LbxReferences: TListBox;
    lbxSequencesSource: TListBox;
    MainMenu1: TMainMenu;
    MakeSeqenceDiagram1: TMenuItem;
    OpenDialogSqDg: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    PgctrlMain: TPageControl;
    pnlNames: TPanel;
    PnReferences: TPanel;
    SaveDialogSqDg: TSaveDialog;
    SequencesMemo: TMemo;
    spBtDelCurDg: TSpeedButton;
    spBtDeleteGroup: TSpeedButton;
    spBtInsCurDg: TSpeedButton;
    spBtLoadGroup: TSpeedButton;
    spBtNewGroup: TSpeedButton;
    spbtRefreshStatistic: TSpeedButton;
    spBtSaveGroup: TSpeedButton;
    SpBtSearchHyperLinksCurrentDiagram: TSpeedButton;
    SpBtSearchHyperLinksCurrentMember: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    TbMain: TToolBar;
    tbsDgGroups: TTabSheet;
    tbsMethodRef: TTabSheet;
    tbsReference: TTabSheet;
    tbsSequences: TTabSheet;
    tbsStatistik: TTabSheet;
    ValidateNames1: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure btFileSaveClick(Sender: TObject);
    procedure btHideClick(Sender: TObject);
    procedure btLoadFromFileClick(Sender: TObject);
    procedure btMoveMsgClick(Sender: TObject);
    procedure btReloadClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FindStringInModel1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GuiHideClick(Sender: TObject);
    procedure lbxMethodRefClick(Sender: TObject);
    procedure LbxReferencesClick(Sender: TObject);
    procedure LbxReferencesDblClick(Sender: TObject);
    procedure LbxReferencesMouseMove(Sender: TObject; Shift: TShiftState; X, Y: 
            Integer);
    procedure lbxSequencesSourceDblClick(Sender: TObject);
    procedure MakeSeqenceDiagram1Click(Sender: TObject);
    procedure PgctrlMainChange(Sender: TObject);
    procedure pnlNamesMouseMove(Sender: TObject; Shift: TShiftState; X, Y: 
            Integer);
    procedure SequencesMemoDblClick(Sender: TObject);
    procedure spBtDelCurDgClick(Sender: TObject);
    procedure spBtDeleteGroupClick(Sender: TObject);
    procedure spBtInsCurDgClick(Sender: TObject);
    procedure spBtLoadGroupClick(Sender: TObject);
    procedure spBtNewGroupClick(Sender: TObject);
    procedure spbtRefreshStatisticClick(Sender: TObject);
    procedure spBtSaveGroupClick(Sender: TObject);
    procedure SpBtSearchHyperLinksCurrentDiagramClick(Sender: TObject);
    procedure SpBtSearchHyperLinksCurrentDiagramMouseMove(Sender: TObject; 
            Shift: TShiftState; X, Y: Integer);
    procedure SpBtSearchHyperLinksCurrentMemberClick(Sender: TObject);
    procedure SpBtSearchHyperLinksCurrentMemberMouseMove(Sender: TObject; 
            Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ValidateNames1Click(Sender: TObject);
  private
    FDiagnose: TDiagnose;
    FDiagramGroupManager: TDiagramGroupManager;
    FExMsg: string;
    FExpertFunctions: TExpertFunctions;
    FMMDiagramExplorer: TMMDiagramExplorer;
    FSymbolNameList: TStringList;
    FToolServices: IMMToolServices;
    procedure GetClassMemberNames(aLine : String; var aClassName,aMemberName : 
            String);
    procedure GetClassMethodProperties;
  public
    procedure AssignDiag(aDiag : TDiagnose);
    procedure DoShowHint(var HintStr: string; var CanShow: Boolean; var 
            HintInfo: THintInfo);
  end;
  
var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

{
*********************************** TFrmMain ***********************************
}
procedure TFrmMain.About1Click(Sender: TObject);
begin
  with TQutronicInfoFrm.Create(NIL) do
  begin
    Timer1.Interval:=10000;
    ShowModal;
    Free;
  end;
end;

procedure TFrmMain.AssignDiag(aDiag : TDiagnose);
begin
  FDiagnose:=aDiag;
end;

procedure TFrmMain.btFileSaveClick(Sender: TObject);
begin
  if SaveDialogSqDg.Execute then
    SequencesMemo.Lines.SaveToFile(SaveDialogSqDg.FileName);
end;

procedure TFrmMain.btHideClick(Sender: TObject);
begin
  Self.WindowState:=wsMinimized;
end;

procedure TFrmMain.btLoadFromFileClick(Sender: TObject);
begin
  if OpenDialogSqDg.Execute then
    SequencesMemo.Lines.LoadFromFile(OpenDialogSqDg.FileName);
end;

procedure TFrmMain.btMoveMsgClick(Sender: TObject);
begin
  SequencesMemo.Lines.Add(lbxSequencesSource.Items[lbxSequencesSource.ItemIndex]);
end;

procedure TFrmMain.btReloadClick(Sender: TObject);
begin
  lbxSequencesSource.Clear;
  GetClassMethodProperties;
end;

procedure TFrmMain.Button1Click(Sender: TObject);
var
  aSeqGen: TDiagramGenerator;
  aSequence: TStringList;
  aId: Integer;
  aIndex: Integer;
begin
  aSeqGen := TDiagramGenerator.Create;
  aSequence:=TStringList.Create;
  aSequence.Assign(SequencesMemo.Lines);
  try
    aId:=aSeqGen.GenSqDg(NIL,'sqAutoGen',aSequence);
    FToolServices.DiagramManager.FindDiagram(aId,aIndex);
    FToolServices.Navigator.CurDiagram:=FToolServices.DiagramManager.Diagrams[aIndex];
  finally
    aSeqGen.Free;
    aSequence.Free;
  end;
end;

procedure TFrmMain.DoShowHint(var HintStr: string; var CanShow: Boolean; var 
        HintInfo: THintInfo);
begin
  CanShow:=True;
  HintInfo.HideTimeout:=20000;
end;

procedure TFrmMain.FindStringInModel1Click(Sender: TObject);
var
  aRefList: TStringList;
  aString: string;
begin
  if InputQuery('String Finder','Enter String:',aString) then
  begin
    aRefList:=TStringList.Create;
    try
      FExpertFunctions.LockupStringReference(aRefList,aString);
      lbxMethodRef.Items.Assign(aRefList);
    finally
      aRefList.Free;
    end;
  end;
end;

procedure TFrmMain.FormActivate(Sender: TObject);
begin
  if not FDiagramGroupManager.GUI_Initialized then
  begin
    FDiagramGroupManager.InitializeGUI;
  end;
end;

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //
end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  cbxDgGroupSelect.Sorted:=True;
  FSymbolNameList:=TStringList.Create;
  FMMDiagramExplorer:=TMMDiagramExplorer.Create;
  FToolServices:=MMToolServices;
  
  FDiagramGroupManager:=TDiagramGroupManager.create;
  FDiagramGroupManager.GUIGroupSelect:=cbxDgGroupSelect;
  FDiagramGroupManager.GUIMemberList:=lbxDgGroupMemberList;
  FExpertFunctions:=TExpertFunctions.Create;
  
  Application.OnShowHint:=DoShowHint;
end;

procedure TFrmMain.FormDestroy(Sender: TObject);
begin
  FMMDiagramExplorer.Free;
  FDiagramGroupManager.Free;
  FSymbolNameList.Free;
  FExpertFunctions.Free;
end;

procedure TFrmMain.GetClassMemberNames(aLine : String; var aClassName,
        aMemberName : String);
var
  aPos: Integer;
begin
  aClassName:='';
  aMemberName:='';
  // extract Classname an Member
  aPos:=Pos('.',aLine);
  if aPos>0 then
  begin
    aClassName:=Copy(aLine,1,aPos-1);
    Delete(aLine,1,Length(aClassName)+1);
    aMemberName:=aLine;
  end
  else
  begin
    aClassName:=aLine;
    aMemberName:='';
  end;
end;

procedure TFrmMain.GetClassMethodProperties;
var
  aClass: IMMClassBase;
  i: Integer;
  aMember: IMMMember;
  n: Integer;
begin
  for i:=0 to FToolServices.CodeModel.ClassCount-1 do
  begin
    aClass:=MMToolServices.CodeModel.Classes[i];
    for n:=0 to aClass.MemberCount-1 do
    begin
      aMember:=aClass.Members[n];
      case aMember.MemberType of
        cpMethod,cpProperty:  lbxSequencesSource.Items.Add(aClass.Name+'.'+aMember.Name);
      end;
    end;
  end;
end;

procedure TFrmMain.GuiHideClick(Sender: TObject);
begin
  close;
end;

procedure TFrmMain.lbxMethodRefClick(Sender: TObject);
var
  S: string;
  aClassName: string;
  aMethodName: string;
  aIdx: Integer;
  ClassMethodEndPos: Integer;
begin
  S:=lbxMethodRef.Items[lbxMethodRef.ItemIndex];
  aClassName:=Copy(S,1,Pos('.',S)-1);
  ClassMethodEndPos:=Pos(' ',S);
  if ClassMethodEndPos<=0 then
    aMethodName:=Copy(S,Pos('.',S)+1,Length(S))
  else
    aMethodName:=Copy(S,Pos('.',S)+1,ClassMethodEndPos-Pos('.',S));
  
  aMethodName:=Trim(aMethodName);
  FExpertFunctions.LocateClass(aClassName);
  if FToolServices.Navigator.CurClass.FindMember(aMethodName,aIdx) then
    FToolServices.Navigator.CurMember:=FToolServices.Navigator.CurClass.Members[aIdx];
end;

procedure TFrmMain.LbxReferencesClick(Sender: TObject);
begin
  //=== TRY
  TRY
  
  FMMDiagramExplorer.GoToDiagram(LbxReferences.ItemIndex);
  pnlNames.Caption:=FSymbolNameList.Strings[LbxReferences.ItemIndex];
  //===
  EXCEPT
    on E: Exception do
    begin
      FExMsg:='Exception in TFrmMain.LbxReferencesClick:'+E.Message;
      if FDiagnose<>nil then
        FDiagnose.Report('E',FExMsg)
      else
        ShowMessage(FExMsg);
    end;
  END;
end;

procedure TFrmMain.LbxReferencesDblClick(Sender: TObject);
begin
  //=== TRY
  TRY
  
  //
  
  //===
  EXCEPT
    on E: Exception do
    begin
      FExMsg:='Exception in TFrmMain.LbxReferencesDblClick:'+E.Message;
      if FDiagnose<>nil then
        FDiagnose.Report('E',FExMsg)
      else
        ShowMessage(FExMsg);
    end;
  END;
end;

procedure TFrmMain.LbxReferencesMouseMove(Sender: TObject; Shift: TShiftState; 
        X, Y: Integer);
var
  aIdx: Integer;
begin
  aIdx:=y div LbxReferences.ItemHeight;
  LbxReferences.Hint:=FMMDiagramExplorer.GetDiagramName(aIdx);
  if LbxReferences.Hint<>'' then
    LbxReferences.ShowHint:=True
  else
    LbxReferences.ShowHint:=False;
end;

procedure TFrmMain.lbxSequencesSourceDblClick(Sender: TObject);
var
  aClassName: string;
  aMemberName: string;
  i: Integer;
  n: Integer;
  aMember: IMMMember;
  aClass: IMMClassBase;
begin
  SequencesMemo.Lines.Add(lbxSequencesSource.Items[lbxSequencesSource.ItemIndex]);
  // SetCurrent Class,Member
  GetClassMemberNames(lbxSequencesSource.Items[lbxSequencesSource.ItemIndex],aClassName,aMemberName);
  for i:=0 to FToolServices.CodeModel.ClassCount-1 do
  begin
    aClass:=FToolServices.CodeModel.Classes[i];
    if UpperCase(aClassName)=UpperCase(aClass.Name) then
    begin
      for n:=0 to aClass.MemberCount-1 do
      begin
        aMember:=aClass.Members[n];
        if UpperCase(aMemberName)=UpperCase(aMember.Name) then
        begin
          FToolServices.Navigator.CurMember:=aMember;
          exit;
        end;
      end;
    end;
  end;
end;

procedure TFrmMain.MakeSeqenceDiagram1Click(Sender: TObject);
var
  aSeqGen: TDiagramGenerator;
  aSequence: TStringList;
  aId: Integer;
  aIndex: Integer;
begin
  if OpenDialogSqDg.Execute then
  begin
    aSeqGen := TDiagramGenerator.Create;
    aSequence:=TStringList.Create;
    aSequence.LoadFromFile(OpenDialogSqDg.FileName);
    try
      aId:=aSeqGen.GenSqDg(NIL,'sq'+ExtractFileName(OpenDialogSqDg.FileName),aSequence);
      FToolServices.DiagramManager.FindDiagram(aId,aIndex);
      FToolServices.Navigator.CurDiagram:=FToolServices.DiagramManager.Diagrams[aIndex];
    finally
      aSeqGen.Free;
      aSequence.Free;
    end;
  end;
end;

procedure TFrmMain.PgctrlMainChange(Sender: TObject);
begin
  // default height: 355 width : 196
  //tbsDgGroups
  if (PgctrlMain.ActivePage=tbsReference) then
  begin
    SpBtSearchHyperLinksCurrentDiagramClick(Sender);
  end
  else
  begin
      //tbsSequences
    if lbxSequencesSource.Items.Count=0 then
      GetClassMethodProperties;
  end;
end;

procedure TFrmMain.pnlNamesMouseMove(Sender: TObject; Shift: TShiftState; X, Y: 
        Integer);
begin
  pnlNames.Hint:=pnlNames.Caption;
end;

procedure TFrmMain.SequencesMemoDblClick(Sender: TObject);
begin
  //
end;

procedure TFrmMain.spBtDelCurDgClick(Sender: TObject);
begin
  FDiagramGroupManager.DeleteDiagramFromGroup;
end;

procedure TFrmMain.spBtDeleteGroupClick(Sender: TObject);
begin
  FDiagramGroupManager.DeleteCurrentGroup;
end;

procedure TFrmMain.spBtInsCurDgClick(Sender: TObject);
begin
  FDiagramGroupManager.AddCurrentDiagram;
end;

procedure TFrmMain.spBtLoadGroupClick(Sender: TObject);
begin
  OpenDialogSqDg.InitialDir:=ExtractFilePath(FDiagramGroupManager.ProjectName);
  if OpenDialogSqDg.Execute then
  begin
    FDiagramGroupManager.LoadFromFile(OpenDialogSqDg.FileName);
  end;
end;

procedure TFrmMain.spBtNewGroupClick(Sender: TObject);
var
  GroupName: string;
begin
  if InputQuery('Diagram Group Managing','Enter New Groupname',GroupName) then
    FDiagramGroupManager.AddGroup(GroupName);
end;

procedure TFrmMain.spbtRefreshStatisticClick(Sender: TObject);
var
  i: Integer;
  invalidMembers: TStringList;
begin
  // FMMDiagramExplorer
  lbDgCount.Caption := IntToStr(FMMDiagramExplorer.DiagramCount);
  // FDiagramGroupManager
  lbxInvalidDGMembers.Clear;
  lbxInvalidDGMembers.Items.Add('Invalid DGMembers:');
  lbxInvalidDGMembers.Items.Add('==================');
  
  invalidMembers:=TStringList.Create;
  try
    FDiagramGroupManager.GetInvalidDGMembers(invalidMembers);
    for i:=0 to invalidMembers.Count-1 do
      lbxInvalidDGMembers.Items.Add(invalidMembers.Strings[i]);
  finally
    invalidMembers.Free;
  end;
end;

procedure TFrmMain.spBtSaveGroupClick(Sender: TObject);
begin
  SaveDialogSqDg.InitialDir:=ExtractFilePath(FDiagramGroupManager.ProjectName);
  if SaveDialogSqDg.Execute then
  begin
    FDiagramGroupManager.SaveToFile(SaveDialogSqDg.FileName);
  end;
end;

procedure TFrmMain.SpBtSearchHyperLinksCurrentDiagramClick(Sender: TObject);
var
  aStringList: TStringList;
begin
  //=== TRY
  TRY
  
  aStringList:=TStringList.Create;
  try
    SpBtSearchHyperLinksCurrentDiagram.Hint:=FMMDiagramExplorer.CurDiagramName;
    SpBtSearchHyperLinksCurrentDiagram.ShowHint:=True;
    FMMDiagramExplorer.GetCurrentDiagramReferences(aStringList,FSymbolNameList);
    LbxReferences.Items.Assign(aStringList);
    if aStringList.Count>0 then
    begin
      pnlNames.Caption:=FSymbolNameList.Strings[0];
    end
    else
      pnlNames.Caption:='---';
  finally
    aStringList.Free;
  end;
  
  //===
  EXCEPT
    on E: Exception do
    begin
      FExMsg:='Exception in TFrmMain.SpBtSearchHyperLinksCurrentDiagramClick:'+E.Message;
      if FDiagnose<>nil then
        FDiagnose.Report('E',FExMsg)
      else
        ShowMessage(FExMsg);
    end;
  END;
end;

procedure TFrmMain.SpBtSearchHyperLinksCurrentDiagramMouseMove(Sender: TObject; 
        Shift: TShiftState; X, Y: Integer);
begin
  SpBtSearchHyperLinksCurrentDiagram.Hint:='Current Diagram: '+FMMDiagramExplorer.CurDiagramName;
  SpBtSearchHyperLinksCurrentDiagram.ShowHint:=True;
end;

procedure TFrmMain.SpBtSearchHyperLinksCurrentMemberClick(Sender: TObject);
var
  aStringList: TStringList;
begin
  //=== TRY
  TRY
  
  aStringList:=TStringList.Create;
  try
    FMMDiagramExplorer.GetCurrentMemberReferences(aStringList,FSymbolNameList);
    LbxReferences.Items.Assign(aStringList);
    if aStringList.Count>0 then
    begin
      pnlNames.Caption:=FSymbolNameList.Strings[0];
    end
    else
      pnlNames.Caption:='---';
  finally
    aStringList.Free;
  end;
  
  //===
  EXCEPT
    on E: Exception do
    begin
      FExMsg:='Exception in TFrmMain.SpBtSearchHyperLinksCurrentMemberClick:'+E.Message;
      if FDiagnose<>nil then
        FDiagnose.Report('E',FExMsg)
      else
        ShowMessage(FExMsg);
    end;
  END;
end;

procedure TFrmMain.SpBtSearchHyperLinksCurrentMemberMouseMove(Sender: TObject; 
        Shift: TShiftState; X, Y: Integer);
begin
  SpBtSearchHyperLinksCurrentMember.Hint:='Current Member: '+FMMDiagramExplorer.CurMemberName;
  SpBtSearchHyperLinksCurrentMember.ShowHint:=True;
end;

procedure TFrmMain.SpeedButton1Click(Sender: TObject);
begin
  with TClipBoard.Create do
  begin
    SetTextBuf(PChar(LbxReferences.Items.Text));
  end;
end;

procedure TFrmMain.SpeedButton2Click(Sender: TObject);
begin
  FMMDiagramExplorer.AddLink;
end;

procedure TFrmMain.ValidateNames1Click(Sender: TObject);
begin
  FDiagramGroupManager.Save;
  FMMDiagramExplorer.ValidateNames;
  FDiagramGroupManager.InitializeGUI;
end;



end.















































