{------------------------------------------------------------------------------

Copyright (C) 2002  Rainer Queck
e-mail: Rainer.Queck@Qutronic.de
http://www.qutronic.de


This code is free; you can redistribute it and/or
modify it under the terms of the MPL MOZILLA PUBLIC LICENSE. 

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
MPL MOZILLA PUBLIC LICENSE for more details at http://www.mozilla.org/MPL

//-----------------------------------------------------------------------------}
// Unit Created at    : somewhen in 2002
// Unit last modified : Date: 17.04.03  Time :08:15:45
//------------------------------------------------------------------------------
unit RQClasses;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TDiagnose = class (TObject)
  private
    FDiagDir: string;
    FExMsg: string;
  public
    constructor Create(ADir : String);
    procedure Report(AType : char ; AMsg : String);
  end;
  

procedure Register;

implementation

procedure Register;
begin
end;

{
********************************** TDiagnose ***********************************
}
constructor TDiagnose.Create(ADir : String);
begin
  TRY
    FDiagDir:=ADir;
    if FDiagDir[length(FDiagDir)]<>'\' then
      FDiagDir:=FDiagDir+'\';
    Report('I','Diagnosis started');
  EXCEPT
    on E: Exception do
    begin
      FExMsg:='Exception in TDiagnose.Create:'+E.Message;
      ShowMessage(FExMsg);
    end;
  END;
end;

procedure TDiagnose.Report(AType : char ; AMsg : String);
var
  DiagFile: string;
  MsgLine: string;
  c: Char;
  F: TextFile;
begin
  TRY
    c := AType;
    MsgLine := TimeToStr(Now)+'-'+ c +': '+AMsg;
  
    DiagFile:=FDiagDir+'Diag_'+FormatDateTime('yyyymmdd',Now)+'.LOG';
    AssignFile(F,DiagFile);
  
    if not FileExists(DiagFile) then
      Rewrite(F);
    Append(F);
    Writeln(F,MsgLine);
    CloseFile(F);
  EXCEPT
    on E: Exception do
    begin
      FExMsg:='Exception in TDiagnose.Report:'+E.Message;
      ShowMessage(FExMsg);
    end;
  END;
end;


end.
